import { Subject } from "rxjs";
import { Http } from "@angular/http";
import { HttpModel } from "../models/http.model";
import { Observable } from 'rxjs/Observable';
import { ResponseHandlerService } from "./response-handler.service";
export declare class HttpService {
    private http;
    private responseHandler;
    constructor(http: Http, responseHandler: ResponseHandlerService);
    ngOnInit(): void;
    setHeaders(headerName: any, headerValue: any): void;
    deleteHeaders(): void;
    private headers;
    restStarted: Subject<{}>;
    restStarted$: Observable<{}>;
    restFinished: Subject<{}>;
    restFinished$: Observable<{}>;
    restSuccess: Subject<{}>;
    restSuccess$: Observable<{}>;
    restError: Subject<{}>;
    restError$: Observable<{}>;
    private initially(params);
    private finally(params);
    private error(params, error);
    private success(params, res);
    get(params: HttpModel): Observable<any>;
    put(params: HttpModel): Observable<any>;
    post(params: HttpModel): Observable<any>;
    delete(params: HttpModel): Observable<any>;
    private getOptions(params);
    private restManager(method, params);
    private restManGet(params, options);
    private restManPut(params, options);
    private restManPost(params, options);
    private restManDelete(params, options);
}
