import { Injectable } from "@angular/core";
import { Subject } from "rxjs";
import { Http, Headers } from "@angular/http";
import { Observable } from 'rxjs/Observable';
import { ResponseHandlerService } from "./response-handler.service";
var HttpService = (function () {
    function HttpService(http, responseHandler) {
        this.http = http;
        this.responseHandler = responseHandler;
        // events supported by library
        // *ON_REST_CALL_STARTED*
        this.restStarted = new Subject();
        this.restStarted$ = this.restStarted.asObservable();
        // *ON_REST_FINISHED*
        this.restFinished = new Subject();
        this.restFinished$ = this.restFinished.asObservable();
        // *ON_REST_SUCCESS*
        this.restSuccess = new Subject();
        this.restSuccess$ = this.restSuccess.asObservable();
        // *ON_REST_ERROR*
        this.restError = new Subject();
        this.restError$ = this.restError.asObservable();
        this.ngOnInit();
    }
    ;
    // INITIAL FUNCTION CALLED BY CONSTRUCTOR ITSELF
    // INITIAL FUNCTION CALLED BY CONSTRUCTOR ITSELF
    HttpService.prototype.ngOnInit = 
    // INITIAL FUNCTION CALLED BY CONSTRUCTOR ITSELF
    function () {
    };
    // CONFIGURATIONS
    // SET HEADERS
    // CONFIGURATIONS
    // SET HEADERS
    HttpService.prototype.setHeaders = 
    // CONFIGURATIONS
    // SET HEADERS
    function (headerName, headerValue) {
        if (!this.headers) {
            this.headers = new Headers();
        }
        this.headers.append(headerName, headerValue);
    };
    // DELETE HEADERS
    // DELETE HEADERS
    HttpService.prototype.deleteHeaders = 
    // DELETE HEADERS
    function () {
        delete this.headers;
    };
    // EVENTS INVOKERS
    // ON REST STARTED THIS EVENT IS INVOKED IRELEAVANT OF SUCCESS OR ERROR
    // EVENTS INVOKERS
    // ON REST STARTED THIS EVENT IS INVOKED IRELEAVANT OF SUCCESS OR ERROR
    HttpService.prototype.initially = 
    // EVENTS INVOKERS
    // ON REST STARTED THIS EVENT IS INVOKED IRELEAVANT OF SUCCESS OR ERROR
    function (params) {
        this.restStarted.next({ params: params });
    };
    // ON REST FINISHED THIS EVENT IS INVOKED IRELEAVANT OF SUCCESS OR ERROR
    // ON REST FINISHED THIS EVENT IS INVOKED IRELEAVANT OF SUCCESS OR ERROR
    HttpService.prototype.finally = 
    // ON REST FINISHED THIS EVENT IS INVOKED IRELEAVANT OF SUCCESS OR ERROR
    function (params) {
        this.restFinished.next({ params: params });
    };
    // ON REST ERROR THIS METHOD IS INVOKED
    // ON REST ERROR THIS METHOD IS INVOKED
    HttpService.prototype.error = 
    // ON REST ERROR THIS METHOD IS INVOKED
    function (params, error) {
        this.restError.next({ error: error, params: params });
    };
    // ON REST SUCCESS THIS METHOD IS INVOKED
    // ON REST SUCCESS THIS METHOD IS INVOKED
    HttpService.prototype.success = 
    // ON REST SUCCESS THIS METHOD IS INVOKED
    function (params, res) {
        this.restSuccess.next({ data: res, params: params });
        if (params.onSucess) {
            params.onSucess({ data: res, params: params });
        }
    };
    // PUBLIC METHODS
    // PUBLIC GET METHOD
    // PUBLIC METHODS
    // PUBLIC GET METHOD
    HttpService.prototype.get = 
    // PUBLIC METHODS
    // PUBLIC GET METHOD
    function (params) {
        this.initially(params);
        return this.restManager('get', params);
    };
    // PUBLIC PUT METHOD
    // PUBLIC PUT METHOD
    HttpService.prototype.put = 
    // PUBLIC PUT METHOD
    function (params) {
        this.initially(params);
        return this.restManager('put', params);
    };
    // PUBLIC POST METHOD
    // PUBLIC POST METHOD
    HttpService.prototype.post = 
    // PUBLIC POST METHOD
    function (params) {
        this.initially(params);
        return this.restManager('post', params);
    };
    // PUBLIC DELETE METHOD
    // PUBLIC DELETE METHOD
    HttpService.prototype.delete = 
    // PUBLIC DELETE METHOD
    function (params) {
        this.initially(params);
        return this.restManager('delete', params);
    };
    // CORE INTERNAL MANUPULATIONS
    // CORE INTERNAL MANUPULATIONS
    HttpService.prototype.getOptions = 
    // CORE INTERNAL MANUPULATIONS
    function (params) {
        var options = new Object();
        options.headers = this.headers;
        if (params.url.queryParam) {
            options.params = params.url.queryParam;
        }
        return options;
    };
    HttpService.prototype.restManager = function (method, params) {
        var options = this.getOptions(params);
        if (method === 'get') {
            return this.restManGet(params, options);
        }
        else if (method === 'put') {
            return this.restManPut(params, options);
        }
        else if (method === 'post') {
            return this.restManPost(params, options);
        }
        else {
            return this.restManDelete(params, options);
        }
    };
    HttpService.prototype.restManGet = function (params, options) {
        var _this = this;
        return this.http
            .get(params.url.compiledUrl, options)
            .map(function (res) {
            res = _this.responseHandler.handle(res, params);
            _this.success(params, res);
            return res;
        })
            .catch(function (err) {
            _this.error(params, err);
            return Observable.of(err);
        })
            .finally(function () {
            _this.finally(params);
        });
    };
    HttpService.prototype.restManPut = function (params, options) {
        var _this = this;
        return this.http
            .put(params.url.compiledUrl, params.payload, options)
            .map(function (res) {
            res = _this.responseHandler.handle(res, params);
            _this.success(params, res);
            return res;
        })
            .catch(function (err) {
            _this.error(params, err);
            return Observable.of(err);
        })
            .finally(function () {
            _this.finally(params);
        });
    };
    HttpService.prototype.restManPost = function (params, options) {
        var _this = this;
        return this.http
            .post(params.url.compiledUrl, params.payload, options)
            .map(function (res) {
            res = _this.responseHandler.handle(res, params);
            _this.success(params, res);
            return res;
        })
            .catch(function (err) {
            _this.error(params, err);
            return Observable.of(err);
        })
            .finally(function () {
            _this.finally(params);
        });
    };
    HttpService.prototype.restManDelete = function (params, options) {
        var _this = this;
        if (params.payload) {
            options.body = params.payload;
        }
        return this.http
            .delete(params.url.compiledUrl, options)
            .map(function (res) {
            res = _this.responseHandler.handle(res, params);
            _this.success(params, res);
            return res;
        })
            .catch(function (err) {
            _this.error(params, err);
            return Observable.of(err);
        })
            .finally(function () {
            _this.finally(params);
        });
    };
    HttpService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    HttpService.ctorParameters = function () { return [
        { type: Http, },
        { type: ResponseHandlerService, },
    ]; };
    return HttpService;
}());
export { HttpService };
// THIS IS COMPATIBLE WITH ANGULAR <=5
// WITH RXJS <=5
// #sandman81
// {{#scripts}}
//# sourceMappingURL=http.service.js.map